
//
//  aseEx.h - *.ASE file parser (Protected Declarations)
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//      This is the memory, file, management, module header.
//
//  Created - 13 Mar, 2002 - James Leiterman
//
//  Last Modification
//
//  stab=4
//



#ifndef aseEx_H
#define aseEx_H

#include    "vmp3D.h"


#ifdef __cplusplus
    extern "C" {
#endif


//
//  3DS Max Labels
//


#define xKEY_3DSMAX_ASCIIEXPORT             "3DSMAX_ASCIIEXPORT"

#define xKEY_SCENE                          "SCENE"             // {  ;;;Level 0
#define xKEY_SCENE_FIRSTFRAME               "SCENE_FIRSTFRAME"
#define xKEY_SCENE_LASTFRAME                "SCENE_LASTFRAME"
#define xKEY_SCENE_FRAMESPEED               "SCENE_FRAMESPEED"
#define xKEY_SCENE_TICKSPERFRAME            "SCENE_TICKSPERFRAME"

//*MATERIAL_LIST {
//  *MATERIAL_COUNT 1
//  *MATERIAL 0 {
//      *MATERIAL_NAME "OldFriends"
//

#define xKEY_MATERIAL_LIST                  "MATERIAL_LIST"     // {  ;;;Level 0
#define xKEY_MATERIAL_COUNT                 "MATERIAL_COUNT"    // #
#define xKEY_MATERIAL                       "MATERIAL"          // # {
#define xKEY_MATERIAL_NAME                  "MATERIAL_NAME"

//      *NUMSUBMTLS 134
//      *SUBMATERIAL 0 {
//          *MATERIAL_NAME "LGrnd11"

#define xKEY_NUMSUBMTLS                     "NUMSUBMTLS"
#define xKEY_SUBMATERIAL                    "SUBMATERIAL"       // # {
#define xKEY_MAP_OPACITY                    "MAP_OPACITY"       // {
#define xKEY_MAP_DIFFUSE                    "MAP_DIFFUSE"
#define xKEY_MAP_NAME                       "MAP_NAME"
#define xKEY_BITMAP                         "BITMAP"

#define xKEY_GEOMOBJECT                     "GEOMOBJECT"
#define xKEY_NODE_NAME                      "NODE_NAME"
#define xKEY_NODE_TM                        "NODE_TM"

#define xKEY_TM_POS                         "TM_POS"            // # # #
#define xKEY_TM_ROTAXIS                     "TM_ROTAXIS"        // # # #
#define xKEY_TM_ROTANGLE                    "TM_ROTANGLE"       // #
#define xKEY_TM_SCALE                       "TM_SCALE"          // # # #
#define xKEY_TM_SCALEAXIS                   "TM_SCALEAXIS"      // # # #
#define xKEY_TM_SCALEAXISANG                "TM_SCALEAXISANG"   // #

//  *MESH {
//      *TIMEVALUE 0
//      *MESH_NUMVERTEX 7072
//      *MESH_NUMFACES 9362

#define xKEY_MESH_ANIMATION                 "MESH_ANIMATION"
#define xKEY_MESH                           "MESH"
#define xKEY_MESH_NUMVERTEX                 "MESH_NUMVERTEX"
#define xKEY_MESH_NUMFACES                  "MESH_NUMFACES"

//      *MESH_VERTEX_LIST {
//          *MESH_VERTEX    0   -53137.00000    -123727.69531   -5586.18848
// use: Vert
#define xKEY_MESH_VERTEX_LIST               "MESH_VERTEX_LIST"
#define xKEY_MESH_VERTEX                    "MESH_VERTEX"

//      *MESH_FACE_LIST {
//          *MESH_FACE    0:    A:    8 B:    9 C:    7 AB:    1 BC:    1 CA:    1   *MESH_SMOOTHING    *MESH_MTLID 12
// use: Face
#define xKEY_MESH_FACE_LIST                 "MESH_FACE_LIST"
#define xKEY_MESH_FACE                      "MESH_FACE"

#define xKEY_MESH_SMOOTHING                 "MESH_SMOOTHING"
#define xKEY_MESH_MTLID                     "MESH_MTLID"        // #

//      *MESH_NUMTVERTEX 66700
//      *MESH_TVERTLIST {
//          *MESH_TVERT 0   0.99950 0.00050 0.50000
// use: Vert
#define xKEY_MESH_NUMTVERTEX                "MESH_NUMTVERTEX"       // 66700
#define xKEY_MESH_TVERTLIST                 "MESH_TVERTLIST"    // {
#define xKEY_MESH_TVERT                     "MESH_TVERT"        // 0    0.99950 0.00050 0.50000

//      *MESH_NUMTVFACES 9362
//      *MESH_TFACELIST {
//          *MESH_TFACE 0   14  13  12

#define xKEY_MESH_NUMTVFACES                "MESH_NUMTVFACES"       // 9362
#define xKEY_MESH_TFACELIST                 "MESH_TFACELIST"            // {
#define xKEY_MESH_TFACE                     "MESH_TFACE"                // 0   14 13 12

//      *MESH_NUMCVERTEX 14508
//      *MESH_CVERTLIST {
//          *MESH_VERTCOL 0 0.48627 0.48627 0.48627
// Use: Vert
#define xKEY_MESH_NUMCVERTEX                "MESH_NUMCVERTEX"       // 14508
#define xKEY_MESH_CVERTLIST                 "MESH_CVERTLIST"            // {
#define xKEY_MESH_VERTCOL                   "MESH_VERTCOL"      // 0    0.48627 0.48627 0.48627

//      *MESH_NUMCVFACES 9362
//      *MESH_CFACELIST {
//          *MESH_CFACE 0   8   9   7

#define xKEY_MESH_NUMCVFACES                "MESH_NUMCVFACES"   // 9362
#define xKEY_MESH_CFACELIST                 "MESH_CFACELIST"    // {
#define xKEY_MESH_CFACE                     "MESH_CFACE"        // 0     8 9 7

//              NOTE: 0...9362
//      *MESH_NORMALS {
//          *MESH_FACENORMAL 0  0.58520 -0.76884    -0.25772
//              *MESH_VERTEXNORMAL 8    0.58520 -0.76884    -0.25772
//              *MESH_VERTEXNORMAL 9    0.58520 -0.76884    -0.25772
//              *MESH_VERTEXNORMAL 7    0.58520 -0.76884    -0.25772
#define xKEY_MESH_NORMALS                   "MESH_NORMALS"      //
#define xKEY_MESH_FACENORMAL                "MESH_FACENORMAL"   //
#define xKEY_MESH_VERTEXNORMAL              "MESH_VERTEXNORMAL" //


//*SHAPEOBJECT {
//  *NODE_NAME "pad00"
//  *NODE_TM {
//      *NODE_NAME "pad00"
//
//  *SHAPE_LINECOUNT 1
//  *SHAPE_LINE 0 {
//      *SHAPE_VERTEXCOUNT 2
//      *SHAPE_VERTEX_KNOT  0   -50700.89063    -121728.73438   -5342.05859
//      *SHAPE_VERTEX_KNOT  1   -50663.05859    -120215.56250   -5342.05859
#define xKEY_SHAPEOBJECT                    "SHAPEOBJECT"
#define xKEY_SHAPE_LINECOUNT                "SHAPE_LINECOUNT"
#define xKEY_SHAPE_LINE                     "SHAPE_LINE"

#define xKEY_SHAPE_CLOSED                   "SHAPE_CLOSED"
#define xKEY_SHAPE_VERTEXCOUNT              "SHAPE_VERTEXCOUNT"
#define xKEY_SHAPE_VERTEX_KNOT              "SHAPE_VERTEX_KNOT"



//
//  Enum Sorted AND Alpha Sorted
//

typedef enum
{
    iKEY_UNKNOWN = 0,
        //  Insert new Id's below this line

    iKEY_BITMAP,
    iKEY_GEOMOBJECT,
    iKEY_MAP_DIFFUSE,
    iKEY_MAP_NAME,
    iKEY_MAP_OPACITY,
    iKEY_MATERIAL,
    iKEY_MATERIAL_COUNT,
    iKEY_MATERIAL_LIST,
    iKEY_MATERIAL_NAME,
    iKEY_MESH,
    iKEY_MESH_ANIMATION,
    iKEY_MESH_CFACE,
    iKEY_MESH_CFACELIST,
    iKEY_MESH_CVERTLIST,
    iKEY_MESH_FACE,
    iKEY_MESH_FACENORMAL,
    iKEY_MESH_FACE_LIST,
    iKEY_MESH_MTLID,
    iKEY_MESH_NORMALS,
    iKEY_MESH_NUMCVERTEX,
    iKEY_MESH_NUMCVFACES,
    iKEY_MESH_NUMFACES,
    iKEY_MESH_NUMTVERTEX,
    iKEY_MESH_NUMTVFACES,
    iKEY_MESH_NUMVERTEX,
    iKEY_MESH_SMOOTHING,
    iKEY_MESH_TFACE,
    iKEY_MESH_TFACELIST,
    iKEY_MESH_TVERT,
    iKEY_MESH_TVERTLIST,
    iKEY_MESH_VERTCOL,
    iKEY_MESH_VERTEX,
    iKEY_MESH_VERTEXNORMAL,
    iKEY_MESH_VERTEX_LIST,
    iKEY_NODE_NAME,
    iKEY_NODE_TM,
    iKEY_NUMSUBMTLS,
    iKEY_SCENE,
    iKEY_SCENE_FIRSTFRAME,
    iKEY_SCENE_FRAMESPEED,
    iKEY_SCENE_LASTFRAME,
    iKEY_SCENE_TICKSPERFRAME,
    iKEY_SHAPEOBJECT,
    iKEY_SHAPE_LINE,
    iKEY_SHAPE_LINECOUNT,
    iKEY_SHAPE_VERTEXCOUNT,
    iKEY_SHAPE_VERTEX_KNOT,
    iKEY_SUBMATERIAL,
    iKEY_TM_POS,
    iKEY_TM_ROTANGLE,
    iKEY_TM_ROTAXIS,
    iKEY_TM_SCALE,
    iKEY_TM_SCALEAXIS,
    iKEY_TM_SCALEAXISANG,

        //  Insert new Id's above this line
    iKEY_MAX
} iKEY;



//
//  Label Type
typedef struct AseLabel
{
    iKEY    keyId;                                      // Key Id (Used for Integrity check! same as index!)
    const char *pszName;                                // Name of Key
} AseLabel;

extern AseLabel AseKeyTbl[];



typedef struct NodeSceneType
{
    uint    nFirstFrame;
    uint    nLastFrame;
    uint    nFrameSpeed;
    uint    TicksPerFrame;
} NodeScene;


//
//  SubMaterial #
//
typedef struct SubMaterialType
{
    char *          pName;
    char *          pMapName;
    char *          pFPath;
} SubMaterial;



//
//  MATERIAL #
//
typedef struct MaterialType
{
    char *          pName;

    uint            nSlot;                              // Tmp. index
    uint            nItemCnt;                           // # of sub-materials
    SubMaterial*    pSubMaterial;                       // Array of sub-materials
} NodeMaterial;



//
//  Face
//

typedef struct FaceType
{
    uint        a;                                      // Vertice Index#
    uint        b;                                      //     "
    uint        c;                                      //     "
    uint        ab;                                     //   1 or 0
    uint        bc;                                     //     "
    uint        ca;                                     //     "
    uint        MaterialId;                             // Texture Index
    int         Smoothing;                              // Smoothing
} Face;



typedef struct TFace
{
    uint        a;
    uint        b;
    uint        c;
    uint        pad;
} TFace;



    //  Face Normal
typedef struct Normal
{
    vmp3DQDVector       vFace;
    vmp3DQDVector       v[3];
    uint                idx[3], pad;
} Normal;


//
//  MESH
//
typedef struct MeshType
{
    uint            TimeValue;

    uint            NumVertex;
    vmp3DQDVector * pVertList;

    uint            NumFaces;
    Face *          pFaceList;

    uint            NumTVertex;
    vmp3DQDVector * pTVertList;

    uint            NumTFaces;
    TFace *         pTFaceList;

    uint            NumCVertex;
    vmp3DQDVector * pCVertList;

    uint            NumCFaces;
    TFace *         pCFaceList;

    uint            NumNormals;
    Normal      *   pNormalList;
} Mesh;
    

//
//  NODE: GEOMOBJECT
//
typedef struct GeomObjectType
{
    vmp3DQDVector   vPos;
    vmp3DQDVector   vRotAxis;
    vmp3DQDVector   vScale;
    vmp3DQDVector   vScaleAxis;
    double          RotAngle;
    double          ScaleAxisAng;

    char *          pName;
    uint            nSlot;                              // Tmp. index

    uint            nItemCnt;                           // # of sub-materials
    Mesh*           pMesh;                              // Array of sub-materials

    uint            nAnimCnt;
    Mesh            *pAni;

} GeomObject;



//
//  List of Waypoints for line
//
typedef struct ShapeLineType
{
    uint            nVertexCnt;
    vmp3DQDVector           VList[1];
} ShapeLine;



//
//  NODE: SHAPEOBJECT
//

typedef struct ShapeObjectType
{
    vmp3DQDVector   vPos;
    vmp3DQDVector   vRotAxis;
    vmp3DQDVector   vScale;
    vmp3DQDVector   vScaleAxis;
    double          RotAngle;
    double          ScaleAxisAng;

    char *          pName;
    uint            nSlot;

    uint            nLineCnt;
    ShapeLine **    pLine;
} ShapeObject;


typedef struct NodeType
{
    struct NodeType *next;

    iKEY    keyId;
    char    *pName;

    uint    nSlot;                                      // Tmp. index
    uint    nItemCnt;
    void    *pData;
} Node;



typedef struct MeshArgsType
{
    GeomObject      *pGeomObject;
    Mesh            *pMesh;

    uint            nCurrentFrame;
    uint            nCnt;
    vmp3DQDVector   *pVertList;
    Face            *pFaceList;
    TFace           *pTFaceList;

    NodeScene       *pScene;
    NodeMaterial    *pMaterial;
    SubMaterial     *pSubMaterial;
    ShapeObject     *pShape;
    ShapeLine       *pShapeLine;
} MeshArgs;






extern AseLabel AseKeyTbl[];

//
//  Function Prototypes
//




#ifdef __cplusplus
}
#endif

#endif  //aseEx_H
