  
//
//  aseWrite.cpp - Relational DataBase Write
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//      This is the ASE Database
//
//  Created - 18 Mar, 2002 - James Leiterman
//
//  Last Modification
//
//  stab=4
//

#include    "KariType.h"                                // Master Definitions

    //  3rd Party Files

#include    <windows.h>
#include    <iostream.h>
#include    <assert.h>
#include    <stdio.h>
#include    <string.h>
#include    <stdlib.h>
#include    <math.h>

    //  Book Development Library Modules
    
#include    "util.h"                                    // General purpose utilities
#include    "ram.h"                                     // Memory Module
#include    "vmp3D.h"
#include    "ase.h"                                     // ASE file parser
#include    "aseEx.h"                                   // ASE file parser (private data)




//
//  Write Textures file name lookup table
//
//  Name is taken from file, although names are usually doctored during development
//  to reflect version #'s, etc. I personally tend to ensure the Game Art Bible uses
//  a naming convention for all art objects that the game needs to know about.
//  The SCENE_FILENAME would work as well!
//
//  It would also be up to you to decide where to park the destination files but I'm
//  just going to write them where the ASE came from!
//
//  The file exported here is to be included as part of your game build!
//
//  I like to do this with an automated enumeration database for managing all textures
//  for all objects with automatic insertions and only updates when an item is new, etc.
//  But I needed to keep it simple for this book. (It's confusing enough!) So this just
//  puts out a plain mid body of a Lookup table for texture names based upon an index
//  related to this one landscape.
//
//  Implement however you like, this is just a quick'n'dirty!

bool aseWriteTextureC( const char * pszFPath, const Node * pNode )
{
    char *p, szFName[MAX_PATH];
    uint n, nLen;
    NodeMaterial *pMaterial;
    SubMaterial *pSubMaterial;
    FILE    *fp;

    strcpy( szFName, pszFPath );
    p = strrchr(szFName, '.');
    ASSERT_PTR(p);

    strcpy(p, "_Tex.C");                                // A 'C' file with same name

    remove(szFName);                                    // Destroy any pre-existing file
    if (NULL == (fp = fopen(szFName, "wb")))
      {
        return false;
      }

    nLen = 0;

        //  Loop for all Nodes

    while(NULL != pNode)
      {
        switch(pNode->keyId)
          {
        case iKEY_MATERIAL_LIST:
            pMaterial = (NodeMaterial*)(pNode->pData);
            pSubMaterial = pMaterial->pSubMaterial;

            if (pMaterial->nItemCnt)
              {
                nLen += fprintf( fp, "\n\n\n//__________________________________________\n" );
                nLen += fprintf( fp, "// The following was automatically generated\n" );
                nLen += fprintf( fp, "//\t%s\n//\n", szFName );
                nLen += fprintf( fp, "//\tfrom %s\n", pszFPath );
                nLen += fprintf( fp, "//\t%u Textures\n//\n", pMaterial->nItemCnt );

                for (n=0; n<pMaterial->nItemCnt; n++, pSubMaterial++ )
                  {
                    nLen += fprintf( fp, "\t\"%s\",\t// +%u %s\n",
                                 pSubMaterial->pFPath, n, pSubMaterial->pMapName );
                  }
                nLen += fprintf( fp, "\n\n" );
                goto pdone;
              }

        default:
            break;
          }

        pNode = pNode->next;
      }

pdone:
    fflush(fp);
    fclose(fp);

    return true;
}



