        TITLE   BcdX86.asm - 80(x)86 BCD Math Snippet
        PAGE    53,160

;  BcdX86.asm - Math Addition & Subtraction
;
;  This document contains file that you may use at your own risk in your own programs.
;
;  This module is designed to accomodate the book.
;
;               This module is designed for fast 3D math
;
;  Created - 3 Oct 2001 - James Leiterman
;
;  Last Modification
;
;       Tabs = 8



        .XLIST

;;;        .387
;;;     .586P   .586    .686   .686P
;;;      .K3D    .XMM    .MMX

        .686
        .XMM

        .model flat, C


        include KariType.inc
        include vmp3DX86M.inc
 
        .LIST


        .data
        align   16


;------------------------------------------------------------------------------------------------


BcdX86  SEGMENT USE32 PUBLIC 'CODE'

;-------------------------------------------------------------------------------------------------



;_________________________________________________________________________________________________
;=================================================================================================
;       BCD Addition
;
;void vmp_BcdAddAsm( byte * pD, byte * pA, byte * pB, uint nCnt )
;{
;       D[] = A[] + B[];
;}

;_________________________________________________________________________________________________

;
        align   16
        public  vmp_BcdAddAsm
vmp_BcdAddAsm       proc    near , pD:ptr, pA:ptr, pB:ptr, nCnt:DWORD
        .K3D
;;;        femms

ASSERT_PTR(pD)
ASSERT_PTR(pA)
ASSERT_PTR(pB)
ASSERT_ZERO(nCnt)

		push	esi
		push	ebx

		mov		ecx,nCnt
		
		mov		edx,pD
		mov		ebx,pB
		mov		esi,pA

		clc

$L1:	mov		al,[esi]
		adc		al,[ebx]
		daa		

		mov		[edx],al
		inc		esi
		inc		ebx
		inc		edx

		dec		ecx		; Each nibble pair!
		jne		$L1

		pop		ebx
		pop		esi
        ret
vmp_BcdAddAsm endp




BcdX86  ends
        end

