
//
//  Bench.cpp - (Scalar) Addition & Subtraction
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//  Created - 5 Oct 2001 - James Leiterman
//
//  Last Modification
//
//
//  stab=4
//

#include "KariType.h"                                   // Master Definitions

    //  3rd Party Libraries
    
#include <iostream.h>
#include <math.h>
#include <memory.h>

    //  Book Development Library Modules

#include "Bcd.h"




//
//  Test 
//
#define MAX_BCD_DIG		16



//
// Print BCD Digits
// NOTE: Stored in reverse byte order!
//

static void PrintBCD( const byte *bcd, uint nCnt )
{
	bcd += nCnt-1;			// Start from end, work forward! (High to Low)

	while (nCnt--)
	{
		byte c;

		c = *bcd--;

		cout << (c>>4) << (c&0x0f) ;
	}
}



//
//	BCD Addition
//
static void testBCDAdd( void )
{
	uint nLoop;
	byte bcd[ MAX_BCD_DIG ];		// Lots of space!

		// Preclear the buffer and seed with (1)!

	memset( bcd, 0, sizeof(bcd) );
	bcd[ 0 ] = 1;			// 0000...0001		2^0
	
		// double the value each loop!
		// NOTE: BCD# is stored backwards so that we can increment through memory
		// note decrement which is more efficient!

	PrintBCD( bcd, MAX_BCD_DIG );
	cout << "  " << (0) << endl;

	for (nLoop = 1; nLoop <= 64; nLoop++)
	{
		vmp_BcdAddAsm( bcd, bcd, bcd, MAX_BCD_DIG );	// A = A+A

		PrintBCD( bcd, MAX_BCD_DIG );

		cout << "  " << (nLoop) << endl;
	}
}



int main( int argc, char *argv[] )
{
    cout <<"\nBCD sample\n\n";

    cout << "Testing BCD Addition " << endl;
    testBCDAdd();

    cout << "Fin!\n\n" << flush;

    return 0;
}

