  
//
//  MComp.h - Motion Compensation
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 21 Feb, 2002 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "KariType.h"                                // Kari Games Master Definitions


#ifndef __MComp_H
#define __MComp_H

#ifdef __cplusplus
extern "C" {
#endif


typedef void (*vmp_MCompProc)( uint8 * pbDst, const uint8 * pbSrc, int iStride );

    //  Horizontal 8x8 Motion Compensation w/Rounding

extern vmp_MCompProc vmp_MCompHz8R;

    //  Horizontal 16x16 Motion Compensation w/Rounding

extern vmp_MCompProc vmp_MCompHz16R;

    //  Vertical 8x8 Motion Compensation w/Rounding

extern vmp_MCompProc vmp_MCompVt8R;

    //  Vertical 16x16 Motion Compensation w/Rounding

extern vmp_MCompProc vmp_MCompVt16R;



#ifdef __cplusplus
}
#endif

#endif  //__MComp_H


