
//
//  yuv12X86.cpp - YUV12 to RGB
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//  Created - 21 Feb, 2002 - James Leiterman
//
//  Last Modification
//
//
//  stab=4
//



#include "KariType.h"                                   // Master Definitions

    //  3rd Party Libraries
    
#include    <assert.h>
#include    <iostream.h>

    //  Book Development Library Modules

#include "CpuAsm.h"    
#include "vmp3D.h"
#include "vmp3DEx.h"
#include "yuv12.h"
#include "yuv12Ex.h"



//
//  Setup YUV12 bit
//
//  NOTE: This function sets up the function vectors so the best function
//      is attached to the vector for the processor running.
//

void yuv12Setup( const CpuInfo * const pcinfo )
{
    ASSERT_PTR(pcinfo);
        
    if ( CPUBITS_SSE2 & pcinfo->nBits )
      {
        vmp_yuv12toRGB32 =      vmp_yuv12toRGB32AsmSSE2;
      }

    else if ( CPUBITS_SSE & pcinfo->nBits )
      {
        vmp_yuv12toRGB32 =      vmp_yuv12toRGB32AsmMMX;
      }

    else if ( CPUBITS_3DNOW & pcinfo->nBits )
      {
        vmp_yuv12toRGB32 =      vmp_yuv12toRGB32AsmMMX;
      }

    else if ( CPUBITS_MMX & pcinfo->nBits )
      {
        vmp_yuv12toRGB32 =      vmp_yuv12toRGB32AsmMMX;
      }

    else
      {
        vmp_yuv12toRGB32 =      vmp_yuv12toRGB32Generic;
      }
}




